Index: branches/3140_NumberSymbol/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessCovarianceOptimizationProblem.cs
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessCovarianceOptimizationProblem.cs	(revision 18100)
+++ branches/3140_NumberSymbol/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessCovarianceOptimizationProblem.cs	(revision 18113)
@@ -97,5 +97,5 @@
 
     private const string ProblemDataParameterName = "ProblemData";
-    private const string ConstantOptIterationsParameterName = "Constant optimization steps";
+    private const string ParameterOptIterationsParameterName = "Parameter optimization steps";
     private const string RestartsParameterName = "Restarts";
 
@@ -108,6 +108,6 @@
       get { return (IValueParameter<IRegressionProblemData>)Parameters[ProblemDataParameterName]; }
     }
-    public IFixedValueParameter<IntValue> ConstantOptIterationsParameter {
-      get { return (IFixedValueParameter<IntValue>)Parameters[ConstantOptIterationsParameterName]; }
+    public IFixedValueParameter<IntValue> ParameterOptIterationsParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters[ParameterOptIterationsParameterName]; }
     }
     public IFixedValueParameter<IntValue> RestartsParameter {
@@ -124,7 +124,7 @@
     IDataAnalysisProblemData IDataAnalysisProblem.ProblemData { get { return ProblemData; } }
 
-    public int ConstantOptIterations {
-      get { return ConstantOptIterationsParameter.Value.Value; }
-      set { ConstantOptIterationsParameter.Value.Value = value; }
+    public int ParameterOptIterations {
+      get { return ParameterOptIterationsParameter.Value.Value; }
+      set { ParameterOptIterationsParameter.Value.Value = value; }
     }
 
@@ -153,6 +153,6 @@
       : base() {
       Parameters.Add(new ValueParameter<IRegressionProblemData>(ProblemDataParameterName, "The data for the regression problem", new RegressionProblemData()));
-      Parameters.Add(new FixedValueParameter<IntValue>(ConstantOptIterationsParameterName, "Number of optimization steps for hyperparameter values", new IntValue(50)));
-      Parameters.Add(new FixedValueParameter<IntValue>(RestartsParameterName, "The number of random restarts for constant optimization.", new IntValue(10)));
+      Parameters.Add(new FixedValueParameter<IntValue>(ParameterOptIterationsParameterName, "Number of optimization steps for hyperparameter values", new IntValue(50)));
+      Parameters.Add(new FixedValueParameter<IntValue>(RestartsParameterName, "The number of random restarts for parameter optimization.", new IntValue(10)));
       Parameters["Restarts"].Hidden = true;
       var g = new SimpleSymbolicExpressionGrammar();
@@ -236,5 +236,5 @@
         double epsx = 0;
         double stpmax = 1;
-        int maxits = ConstantOptIterations;
+        int maxits = ParameterOptIterations;
         alglib.mincgstate state;
         alglib.mincgreport rep;
@@ -384,4 +384,12 @@
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
+      if (!Parameters.ContainsKey(ParameterOptIterationsParameterName)) {
+        if (Parameters.ContainsKey("Constant optimization steps")) {
+          Parameters.Add(new FixedValueParameter<IntValue>(ParameterOptIterationsParameterName, "Number of optimization steps for hyperparameter values", (IntValue)Parameters["Constant optimization steps"].ActualValue));
+          Parameters.Remove("Constant optimization steps");
+        } else {
+          Parameters.Add(new FixedValueParameter<IntValue>(ParameterOptIterationsParameterName, "Number of optimization steps for hyperparameter values", new IntValue(50)));
+        }
+      }
     }
 
Index: branches/3140_NumberSymbol/HeuristicLab.Algorithms.DataAnalysis/3.4/NonlinearRegression/NonlinearRegression.cs
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.Algorithms.DataAnalysis/3.4/NonlinearRegression/NonlinearRegression.cs	(revision 18100)
+++ branches/3140_NumberSymbol/HeuristicLab.Algorithms.DataAnalysis/3.4/NonlinearRegression/NonlinearRegression.cs	(revision 18113)
@@ -263,5 +263,5 @@
       }
 
-      if (!SymbolicRegressionConstantOptimizationEvaluator.CanOptimizeConstants(tree)) throw new ArgumentException("The optimizer does not support the specified model structure.");
+      if (!SymbolicRegressionParameterOptimizationEvaluator.CanOptimizeParameters(tree)) throw new ArgumentException("The optimizer does not support the specified model structure.");
 
       // initialize constants randomly
@@ -275,7 +275,7 @@
       var interpreter = new SymbolicDataAnalysisExpressionTreeLinearInterpreter();
 
-      SymbolicRegressionConstantOptimizationEvaluator.OptimizeConstants(interpreter, tree, problemData, problemData.TrainingIndices,
+      SymbolicRegressionParameterOptimizationEvaluator.OptimizeParameters(interpreter, tree, problemData, problemData.TrainingIndices,
         applyLinearScaling: applyLinearScaling, maxIterations: maxIterations,
-        updateVariableWeights: false, updateConstantsInTree: true);
+        updateVariableWeights: false, updateParametersInTree: true);
 
       var model = new SymbolicRegressionModel(problemData.TargetVariable, tree, (ISymbolicDataAnalysisExpressionTreeInterpreter)interpreter.Clone());