Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Symbols/ConstantView.Designer.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Symbols/ConstantView.Designer.cs	(revision 17180)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Symbols/ConstantView.Designer.cs	(revision 18132)
@@ -45,17 +45,7 @@
     /// </summary>
     private void InitializeComponent() {
-      this.weightNuLabel = new System.Windows.Forms.Label();
-      this.minValueTextBox = new System.Windows.Forms.TextBox();
-      this.initializationGroupBox = new System.Windows.Forms.GroupBox();
-      this.weightSigmaLabel = new System.Windows.Forms.Label();
-      this.maxValueTextBox = new System.Windows.Forms.TextBox();
-      this.mutationGroupBox = new System.Windows.Forms.GroupBox();
-      this.multiplicativeChangeLabel = new System.Windows.Forms.Label();
-      this.multiplicativeChangeSigmaTextBox = new System.Windows.Forms.TextBox();
-      this.additiveChangeLabel = new System.Windows.Forms.Label();
-      this.additiveChangeSigmaTextBox = new System.Windows.Forms.TextBox();
+      this.valueLabel = new System.Windows.Forms.Label();
+      this.valueTextBox = new System.Windows.Forms.TextBox();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-      this.initializationGroupBox.SuspendLayout();
-      this.mutationGroupBox.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -68,4 +58,12 @@
       this.errorProvider.SetIconAlignment(this.initialFrequencyTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
       this.initialFrequencyTextBox.Size = new System.Drawing.Size(280, 20);
+      // 
+      // minimumArityLabel
+      // 
+      this.toolTip.SetToolTip(this.minimumArityLabel, "The minimum arity of the symbol");
+      // 
+      // maximumArityLabel
+      // 
+      this.toolTip.SetToolTip(this.maximumArityLabel, "The maximum arity of the symbol");
       // 
       // minimumArityTextBox
@@ -89,134 +87,38 @@
       this.infoLabel.Location = new System.Drawing.Point(379, 3);
       // 
-      // weightNuLabel
+      // valueLabel
       // 
-      this.weightNuLabel.AutoSize = true;
-      this.weightNuLabel.Location = new System.Drawing.Point(6, 22);
-      this.weightNuLabel.Name = "weightNuLabel";
-      this.weightNuLabel.Size = new System.Drawing.Size(56, 13);
-      this.weightNuLabel.TabIndex = 0;
-      this.weightNuLabel.Text = "Min value:";
-      this.toolTip.SetToolTip(this.weightNuLabel, "The minimal value to use for random initialization of constants.");
+      this.valueLabel.AutoSize = true;
+      this.valueLabel.Location = new System.Drawing.Point(3, 130);
+      this.valueLabel.Name = "valueLabel";
+      this.valueLabel.Size = new System.Drawing.Size(37, 13);
+      this.valueLabel.TabIndex = 0;
+      this.valueLabel.Text = "Value:";
+      this.toolTip.SetToolTip(this.valueLabel, "The value of the constant.");
       // 
-      // minValueTextBox
+      // valueTextBox
       // 
-      this.minValueTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.valueTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.errorProvider.SetIconAlignment(this.minValueTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.minValueTextBox.Location = new System.Drawing.Point(92, 19);
-      this.minValueTextBox.Name = "minValueTextBox";
-      this.minValueTextBox.Size = new System.Drawing.Size(300, 20);
-      this.minValueTextBox.TabIndex = 1;
-      this.toolTip.SetToolTip(this.minValueTextBox, "The minimal value to use for random initialization of constants.");
-      this.minValueTextBox.TextChanged += new System.EventHandler(this.minValueTextBox_TextChanged);
-      // 
-      // initializationGroupBox
-      // 
-      this.initializationGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.initializationGroupBox.Controls.Add(this.weightSigmaLabel);
-      this.initializationGroupBox.Controls.Add(this.maxValueTextBox);
-      this.initializationGroupBox.Controls.Add(this.weightNuLabel);
-      this.initializationGroupBox.Controls.Add(this.minValueTextBox);
-      this.initializationGroupBox.Location = new System.Drawing.Point(0, 127);
-      this.initializationGroupBox.Name = "initializationGroupBox";
-      this.initializationGroupBox.Size = new System.Drawing.Size(398, 73);
-      this.initializationGroupBox.TabIndex = 5;
-      this.initializationGroupBox.TabStop = false;
-      this.initializationGroupBox.Text = "Initialization";
-      // 
-      // weightSigmaLabel
-      // 
-      this.weightSigmaLabel.AutoSize = true;
-      this.weightSigmaLabel.Location = new System.Drawing.Point(6, 48);
-      this.weightSigmaLabel.Name = "weightSigmaLabel";
-      this.weightSigmaLabel.Size = new System.Drawing.Size(59, 13);
-      this.weightSigmaLabel.TabIndex = 2;
-      this.weightSigmaLabel.Text = "Max value:";
-      this.toolTip.SetToolTip(this.weightSigmaLabel, "The maximal value to use for random initialization of constants.");
-      // 
-      // maxValueTextBox
-      // 
-      this.maxValueTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.errorProvider.SetIconAlignment(this.maxValueTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.maxValueTextBox.Location = new System.Drawing.Point(92, 45);
-      this.maxValueTextBox.Name = "maxValueTextBox";
-      this.maxValueTextBox.Size = new System.Drawing.Size(300, 20);
-      this.maxValueTextBox.TabIndex = 3;
-      this.toolTip.SetToolTip(this.maxValueTextBox, "The maximal value to use for random initialization of constants.");
-      this.maxValueTextBox.TextChanged += new System.EventHandler(this.maxValueTextBox_TextChanged);
-      // 
-      // mutationGroupBox
-      // 
-      this.mutationGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.mutationGroupBox.Controls.Add(this.multiplicativeChangeLabel);
-      this.mutationGroupBox.Controls.Add(this.multiplicativeChangeSigmaTextBox);
-      this.mutationGroupBox.Controls.Add(this.additiveChangeLabel);
-      this.mutationGroupBox.Controls.Add(this.additiveChangeSigmaTextBox);
-      this.mutationGroupBox.Location = new System.Drawing.Point(0, 206);
-      this.mutationGroupBox.Name = "mutationGroupBox";
-      this.mutationGroupBox.Size = new System.Drawing.Size(398, 73);
-      this.mutationGroupBox.TabIndex = 6;
-      this.mutationGroupBox.TabStop = false;
-      this.mutationGroupBox.Text = "Mutation";
-      // 
-      // multiplicativeChangeLabel
-      // 
-      this.multiplicativeChangeLabel.AutoSize = true;
-      this.multiplicativeChangeLabel.Location = new System.Drawing.Point(6, 48);
-      this.multiplicativeChangeLabel.Name = "multiplicativeChangeLabel";
-      this.multiplicativeChangeLabel.Size = new System.Drawing.Size(146, 13);
-      this.multiplicativeChangeLabel.TabIndex = 2;
-      this.multiplicativeChangeLabel.Text = "Multiplicative change (sigma):";
-      this.toolTip.SetToolTip(this.multiplicativeChangeLabel, "The sigma (std. dev.) parameter for the normal distribution to use to sample the " +
-        "multiplicative change.");
-      // 
-      // multiplicativeChangeSigmaTextBox
-      // 
-      this.multiplicativeChangeSigmaTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.errorProvider.SetIconAlignment(this.multiplicativeChangeSigmaTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.multiplicativeChangeSigmaTextBox.Location = new System.Drawing.Point(168, 45);
-      this.multiplicativeChangeSigmaTextBox.Name = "multiplicativeChangeSigmaTextBox";
-      this.multiplicativeChangeSigmaTextBox.Size = new System.Drawing.Size(224, 20);
-      this.multiplicativeChangeSigmaTextBox.TabIndex = 3;
-      this.toolTip.SetToolTip(this.multiplicativeChangeSigmaTextBox, "The sigma (std. dev.) parameter for the normal distribution to use to sample a mu" +
-        "ltiplicative change.");
-      this.multiplicativeChangeSigmaTextBox.TextChanged += new System.EventHandler(this.multiplicativeChangeSigmaTextBox_TextChanged);
-      // 
-      // additiveChangeLabel
-      // 
-      this.additiveChangeLabel.AutoSize = true;
-      this.additiveChangeLabel.Location = new System.Drawing.Point(6, 22);
-      this.additiveChangeLabel.Name = "additiveChangeLabel";
-      this.additiveChangeLabel.Size = new System.Drawing.Size(123, 13);
-      this.additiveChangeLabel.TabIndex = 0;
-      this.additiveChangeLabel.Text = "Additive change (sigma):";
-      this.toolTip.SetToolTip(this.additiveChangeLabel, "The sigma (std. dev.) parameter for the normal distribution to sample the additiv" +
-        "e change.");
-      // 
-      // additiveChangeSigmaTextBox
-      // 
-      this.additiveChangeSigmaTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.errorProvider.SetIconAlignment(this.additiveChangeSigmaTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.additiveChangeSigmaTextBox.Location = new System.Drawing.Point(168, 19);
-      this.additiveChangeSigmaTextBox.Name = "additiveChangeSigmaTextBox";
-      this.additiveChangeSigmaTextBox.Size = new System.Drawing.Size(224, 20);
-      this.additiveChangeSigmaTextBox.TabIndex = 1;
-      this.toolTip.SetToolTip(this.additiveChangeSigmaTextBox, "The sigma (std. dev.) parameter for the normal distribution to use to sample an a" +
-        "dditive change.");
-      this.additiveChangeSigmaTextBox.TextChanged += new System.EventHandler(this.additiveChangeSigmaTextBox_TextChanged);
+      this.errorProvider.SetIconAlignment(this.valueTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.valueTextBox.Location = new System.Drawing.Point(93, 127);
+      this.valueTextBox.Name = "valueTextBox";
+      this.valueTextBox.Size = new System.Drawing.Size(280, 20);
+      this.valueTextBox.TabIndex = 1;
+      this.toolTip.SetToolTip(this.valueTextBox, "The value of the constant.");
+      this.valueTextBox.TextChanged += new System.EventHandler(this.valueTextBox_TextChanged);
       // 
       // ConstantView
       // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
-      this.Controls.Add(this.mutationGroupBox);
-      this.Controls.Add(this.initializationGroupBox);
+      this.Controls.Add(this.valueLabel);
+      this.Controls.Add(this.valueTextBox);
       this.Name = "ConstantView";
-      this.Size = new System.Drawing.Size(398, 284);
+      this.Size = new System.Drawing.Size(398, 168);
+      this.Controls.SetChildIndex(this.valueTextBox, 0);
+      this.Controls.SetChildIndex(this.valueLabel, 0);
+      this.Controls.SetChildIndex(this.enabledCheckBox, 0);
+      this.Controls.SetChildIndex(this.initialFrequencyLabel, 0);
+      this.Controls.SetChildIndex(this.initialFrequencyTextBox, 0);
       this.Controls.SetChildIndex(this.maximumArityLabel, 0);
       this.Controls.SetChildIndex(this.maximumArityTextBox, 0);
@@ -224,15 +126,7 @@
       this.Controls.SetChildIndex(this.minimumArityTextBox, 0);
       this.Controls.SetChildIndex(this.infoLabel, 0);
-      this.Controls.SetChildIndex(this.initializationGroupBox, 0);
-      this.Controls.SetChildIndex(this.initialFrequencyTextBox, 0);
-      this.Controls.SetChildIndex(this.initialFrequencyLabel, 0);
       this.Controls.SetChildIndex(this.nameLabel, 0);
       this.Controls.SetChildIndex(this.nameTextBox, 0);
-      this.Controls.SetChildIndex(this.mutationGroupBox, 0);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
-      this.initializationGroupBox.ResumeLayout(false);
-      this.initializationGroupBox.PerformLayout();
-      this.mutationGroupBox.ResumeLayout(false);
-      this.mutationGroupBox.PerformLayout();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -242,15 +136,6 @@
     #endregion
 
-    private System.Windows.Forms.Label weightNuLabel;
-    private System.Windows.Forms.TextBox minValueTextBox;
-    protected System.Windows.Forms.GroupBox initializationGroupBox;
-    private System.Windows.Forms.Label weightSigmaLabel;
-    private System.Windows.Forms.TextBox maxValueTextBox;
-    protected System.Windows.Forms.GroupBox mutationGroupBox;
-    private System.Windows.Forms.Label multiplicativeChangeLabel;
-    private System.Windows.Forms.TextBox multiplicativeChangeSigmaTextBox;
-    private System.Windows.Forms.Label additiveChangeLabel;
-    private System.Windows.Forms.TextBox additiveChangeSigmaTextBox;
-
+    private System.Windows.Forms.Label valueLabel;
+    private System.Windows.Forms.TextBox valueTextBox;
   }
 }