Index: branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeBottomUpSimilarityCalculator.cs
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeBottomUpSimilarityCalculator.cs	(revision 18135)
+++ branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeBottomUpSimilarityCalculator.cs	(revision 18140)
@@ -41,5 +41,5 @@
     protected override bool IsCommutative { get { return true; } }
 
-    public bool MatchParameterValues { get; set; }
+    public bool MatchNumericValues { get; set; }
     public bool MatchVariableWeights { get; set; }
 
@@ -74,5 +74,5 @@
 
     public static NodeMap ComputeBottomUpMapping(ISymbolicExpressionTreeNode n1, ISymbolicExpressionTreeNode n2, bool strict = false) {
-      var calculator = new SymbolicExpressionTreeBottomUpSimilarityCalculator { MatchParameterValues = strict, MatchVariableWeights = strict };
+      var calculator = new SymbolicExpressionTreeBottomUpSimilarityCalculator { MatchNumericValues = strict, MatchVariableWeights = strict };
       return calculator.ComputeBottomUpMapping(n1, n2);
     }
@@ -211,5 +211,5 @@
 
       if (node is INumericTreeNode numNode)
-        return MatchParameterValues ? numNode.Value.ToString(CultureInfo.InvariantCulture) : "Numeric";
+        return MatchNumericValues ? numNode.Value.ToString(CultureInfo.InvariantCulture) : "Numeric";
 
       if (node is VariableTreeNode variable)
Index: branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeEqualityComparer.cs
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeEqualityComparer.cs	(revision 18135)
+++ branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeEqualityComparer.cs	(revision 18140)
@@ -33,5 +33,5 @@
     protected SymbolicExpressionTreeNodeEqualityComparer(SymbolicExpressionTreeNodeEqualityComparer original, Cloner cloner)
       : base(original, cloner) {
-      matchParameterValues = original.matchParameterValues;
+      matchNumericValues = original.matchNumericValues;
       matchVariableNames = original.matchVariableNames;
       matchVariableWeights = original.matchVariableWeights;
@@ -41,8 +41,8 @@
     // more flexible matching criteria 
     [Storable]
-    private bool matchParameterValues;
+    private bool matchNumericValues;
     public bool MatchParameterValues {
-      get { return matchParameterValues; }
-      set { matchParameterValues = value; }
+      get { return matchNumericValues; }
+      set { matchNumericValues = value; }
     }
 
@@ -66,5 +66,5 @@
 
     public SymbolicExpressionTreeNodeEqualityComparer() {
-      matchParameterValues = true;
+      matchNumericValues = true;
       matchVariableNames = true;
       matchVariableWeights = true;
Index: branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblemData.cs
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblemData.cs	(revision 18135)
+++ branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblemData.cs	(revision 18140)
@@ -189,5 +189,9 @@
       if (variableRanges == null) {
         variableRanges = Dataset.GetVariableRanges();
-      }
+      }else {
+        foreach (var entry in variableRanges.GetVariableIntervals())
+          VariableRanges.SetInterval(entry.Item1, entry.Item2);
+      }
+
       Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, variableRanges));
 
Index: branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 18135)
+++ branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 18140)
@@ -158,13 +158,9 @@
 
     public RegressionProblemData(IDataset dataset, IEnumerable<string> allowedInputVariables, string targetVariable,
-      IEnumerable<ITransformation> transformations = null/*,
-      IntervalCollection variableRanges = null*/)
-      : base(dataset, allowedInputVariables, transformations ?? Enumerable.Empty<ITransformation>()) {
+      IEnumerable<ITransformation> transformations = null,  IntervalCollection variableRanges = null)
+      : base(dataset, allowedInputVariables, transformations, variableRanges) {
       var variables = InputVariables.Select(x => x.AsReadOnly()).ToList();
       Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>(variables), variables.Where(x => x.Value == targetVariable).First()));
-      /*if (variableRanges == null) {
-        variableRanges = Dataset.GetVariableRanges();
-      }
-      Parameters.Add(new FixedValueParameter<IntervalCollection>(VariableRangesParameterName, variableRanges));*/
+     
     }
     private void RegisterParameterEvents() {
Index: branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ShapeConstrainedRegressionProblemData.cs
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ShapeConstrainedRegressionProblemData.cs	(revision 18135)
+++ branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/ShapeConstrainedRegressionProblemData.cs	(revision 18140)
@@ -144,13 +144,12 @@
     public ShapeConstrainedRegressionProblemData(IRegressionProblemData regressionProblemData)
       : this(regressionProblemData.Dataset, regressionProblemData.AllowedInputVariables, regressionProblemData.TargetVariable,
-          regressionProblemData.TrainingPartition, regressionProblemData.TestPartition, regressionProblemData.Transformations,
-          (regressionProblemData is ShapeConstrainedRegressionProblemData) ? ((ShapeConstrainedRegressionProblemData)regressionProblemData).ShapeConstraints : null,
-          regressionProblemData.VariableRanges) {
+          regressionProblemData.TrainingPartition, regressionProblemData.TestPartition, (regressionProblemData is ShapeConstrainedRegressionProblemData) ? ((ShapeConstrainedRegressionProblemData)regressionProblemData).ShapeConstraints : null,
+          regressionProblemData.Transformations, regressionProblemData.VariableRanges) {
     }
 
     public ShapeConstrainedRegressionProblemData(IDataset dataset, IEnumerable<string> allowedInputVariables, string targetVariable,
-                                                 IntRange trainingPartition, IntRange testPartition,
-                                                 IEnumerable<ITransformation> transformations = null, ShapeConstraints sc = null, IntervalCollection variableRanges = null)
-    : base(dataset, allowedInputVariables, targetVariable, transformations ?? Enumerable.Empty<ITransformation>()) {
+                                                 IntRange trainingPartition, IntRange testPartition, ShapeConstraints sc = null,
+                                                 IEnumerable<ITransformation> transformations = null,  IntervalCollection variableRanges = null)
+    : base(dataset, allowedInputVariables, targetVariable, transformations, variableRanges) {
       TrainingPartition.Start = trainingPartition.Start;
       TrainingPartition.End = trainingPartition.End;
@@ -159,8 +158,4 @@
       if (sc == null) sc = new ShapeConstraints();
       Parameters.Add(new FixedValueParameter<ShapeConstraints>(ShapeConstraintsParameterName, "Specifies the shape constraints for the regression problem.", (ShapeConstraints)sc.Clone()));
-      if (variableRanges != null) {
-        foreach (var entry in variableRanges.GetVariableIntervals())
-          VariableRanges.SetInterval(entry.Item1, entry.Item2);
-      }
       RegisterEventHandlers();
     }