Index: branches/3140_NumberSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/instruction.h
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/instruction.h	(revision 18147)
+++ branches/3140_NumberSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/instruction.h	(revision 18159)
@@ -19,5 +19,5 @@
     Exp                = 9,
     Var                = 18,
-    Const              = 20,
+    Number             = 20,
     Power              = 22,
     Root               = 23,
@@ -28,5 +28,6 @@
     Cube               = 50,
     CubeRoot           = 51,
-    Tanh               = 52
+    Tanh               = 52,
+    Constant           = 54
 };
 
Index: branches/3140_NumberSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.cpp
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.cpp	(revision 18147)
+++ branches/3140_NumberSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.cpp	(revision 18159)
@@ -32,5 +32,5 @@
         in.buf = buffer + (i * BATCHSIZE);
 
-        if (in.opcode == OpCodes::Const)
+        if (in.opcode == OpCodes::Constant || in.opcode == OpCodes::Number)
         {
             load(in.buf, in.value);
Index: branches/3140_NumberSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.h
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.h	(revision 18147)
+++ branches/3140_NumberSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.h	(revision 18159)
@@ -12,5 +12,6 @@
         switch (in.opcode)
         {
-            case OpCodes::Const: /* nothing to do */ break;
+            case OpCodes::Number: /* nothing to do */ break;
+            case OpCodes::Constant: /* nothing to do */ break;
             case OpCodes::Var:
                 {
@@ -165,5 +166,6 @@
                     break;
                 }
-            case OpCodes::Const: /* nothing to do because buffers for constants are already set */ break;
+            case OpCodes::Number: /* nothing to do because buffers for numbers are already set */ break;
+            case OpCodes::Constant: /* nothing to do because buffers for constants are already set */ break;
             case OpCodes::Add:
                 {
Index: branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/OpCodes.cs
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/OpCodes.cs	(revision 18147)
+++ branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/OpCodes.cs	(revision 18159)
@@ -79,5 +79,5 @@
     CubeRoot = 51,
     Tanh = 52,
-    Constant = 53
+    Constant = 54
   };
   public static class OpCodes {
Index: branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs
===================================================================
--- branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs	(revision 18147)
+++ branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs	(revision 18159)
@@ -103,4 +103,5 @@
     private static readonly HashSet<byte> supportedOpCodes = new HashSet<byte>() {
       (byte)OpCode.Constant,
+      (byte)OpCode.Number,
       (byte)OpCode.Variable,
       (byte)OpCode.Add,