Index: /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonDateTimeFilterView.cs
===================================================================
--- /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonDateTimeFilterView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonDateTimeFilterView.cs	(revision 18166)
@@ -52,9 +52,11 @@
 
     private void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         label.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         valueTextBox.Text = Content.Value.ToString();
         label.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonDoubleFilterView.cs
===================================================================
--- /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonDoubleFilterView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonDoubleFilterView.cs	(revision 18166)
@@ -51,9 +51,11 @@
 
     private void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         label.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         valueTextBox.Text = Content.Value.ToString();
         label.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonFloatFilterView.cs
===================================================================
--- /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonFloatFilterView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonFloatFilterView.cs	(revision 18166)
@@ -51,9 +51,11 @@
 
     private void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         label.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         valueTextBox.Text = Content.Value.ToString();
         label.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonIntFilterView.cs
===================================================================
--- /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonIntFilterView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonIntFilterView.cs	(revision 18166)
@@ -51,9 +51,11 @@
 
     private void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         label.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         valueTextBox.Text = Content.Value.ToString();
         label.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonLongFilterView.cs
===================================================================
--- /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonLongFilterView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonLongFilterView.cs	(revision 18166)
@@ -51,9 +51,11 @@
 
     private void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         label.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         valueTextBox.Text = Content.Value.ToString();
         label.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonPercentFilterView.cs
===================================================================
--- /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonPercentFilterView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonPercentFilterView.cs	(revision 18166)
@@ -58,9 +58,11 @@
 
     private void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         label.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         valueTextBox.Text = Content.Value.ToString();
         label.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonTimeSpanFilterView.cs
===================================================================
--- /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonTimeSpanFilterView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/OrdinalComparisonTimeSpanFilterView.cs	(revision 18166)
@@ -59,9 +59,11 @@
 
     private void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         label.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         valueTextBox.Text = Content.Value.ToString();
         label.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/StringComparisonAvailableValuesFilterView.cs
===================================================================
--- /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/StringComparisonAvailableValuesFilterView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/StringComparisonAvailableValuesFilterView.cs	(revision 18166)
@@ -82,9 +82,11 @@
 
     private void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         label.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         valueComboBox.Text = Content.Value;
         label.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/StringComparisonFilterView.cs
===================================================================
--- /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/StringComparisonFilterView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Clients.OKB.Views/3.3/Query/Views/StringComparisonFilterView.cs	(revision 18166)
@@ -82,9 +82,11 @@
 
     private void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         label.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         valueTextBox.Text = Content.Value;
         label.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Core.Views/3.3/NamedItemView.cs
===================================================================
--- /trunk/HeuristicLab.Core.Views/3.3/NamedItemView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Core.Views/3.3/NamedItemView.cs	(revision 18166)
@@ -119,9 +119,11 @@
     }
     protected virtual void nameTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         nameLabel.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         nameTextBox.Text = Content.Name;
         nameLabel.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs
===================================================================
--- /trunk/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs	(revision 18166)
@@ -156,9 +156,11 @@
     }
     private void lengthTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return)
+      if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return) {
         lengthLabel.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         lengthTextBox.Text = Content.Length.ToString();
         lengthLabel.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
@@ -249,5 +251,5 @@
         clipboardText = clipboardText.Remove(clipboardText.Length - Environment.NewLine.Length);  //remove last newline constant
 
-      var lines = clipboardText.Split(new [] { Environment.NewLine }, StringSplitOptions.None);
+      var lines = clipboardText.Split(new[] { Environment.NewLine }, StringSplitOptions.None);
       var tabSep = new[] { '\t' };
       if (lines.Length > 2) {
Index: /trunk/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs
===================================================================
--- /trunk/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs	(revision 18166)
@@ -227,9 +227,11 @@
     }
     private void rowsTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return)
+      if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return) {
         rowsLabel.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         rowsTextBox.Text = Content.Rows.ToString();
         rowsLabel.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
@@ -249,9 +251,11 @@
     }
     private void columnsTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return)
+      if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return) {
         columnsLabel.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         columnsTextBox.Text = Content.Columns.ToString();
         columnsLabel.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Data.Views/3.3/TextValueView.cs
===================================================================
--- /trunk/HeuristicLab.Data.Views/3.3/TextValueView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Data.Views/3.3/TextValueView.cs	(revision 18166)
@@ -86,10 +86,11 @@
 
     protected virtual void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if (e.Shift && (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return))
+      if (e.Shift && (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return)) {
         valueLabel.Select();  // select label to validate data
-
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         valueTextBox.Text = Content.GetValue();
         valueLabel.Select();  // select label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolView.cs
===================================================================
--- /trunk/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolView.cs	(revision 18166)
@@ -70,10 +70,11 @@
     #region control event handlers
     private void initialFrequencyTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         initialFrequencyLabel.Select();  // select label to validate data
-
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else  if (e.KeyCode == Keys.Escape) {
         initialFrequencyTextBox.Text = Content.InitialFrequency.ToString();
         initialFrequencyLabel.Select();  // select label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Parameters.Views/3.3/ScopeTreeLookupParameterView.cs
===================================================================
--- /trunk/HeuristicLab.Parameters.Views/3.3/ScopeTreeLookupParameterView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Parameters.Views/3.3/ScopeTreeLookupParameterView.cs	(revision 18166)
@@ -106,9 +106,11 @@
     }
     protected virtual void depthTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         depthLabel.Focus();  // set focus on label to validate data
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         depthTextBox.Text = Content.Depth.ToString();
         depthLabel.Focus();  // set focus on label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/TimeframeFeatureCorrelationView.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/TimeframeFeatureCorrelationView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/TimeframeFeatureCorrelationView.cs	(revision 18166)
@@ -70,9 +70,9 @@
       if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return) {
         timeFrameLabel.Select();  // select label to validate data
-      }
-
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else  if (e.KeyCode == Keys.Escape) {
         timeframeTextbox.Text = lastFramesValue;
         timeFrameLabel.Select();  // select label to validate data
+        e.SuppressKeyPress = true;
       }
     }
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/TimeSeriesPrognosis/TimeSeriesPrognosisResultsView.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/TimeSeriesPrognosis/TimeSeriesPrognosisResultsView.cs	(revision 18165)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/TimeSeriesPrognosis/TimeSeriesPrognosisResultsView.cs	(revision 18166)
@@ -107,10 +107,11 @@
 
     private void TrainingHorizonTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         TrainingHorizonLabel.Select();  // select label to validate data
-
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         TrainingHorizonTextBox.Text = Content.TrainingHorizon.ToString();
         TrainingHorizonLabel.Select();  // select label to validate data
+        e.SuppressKeyPress = true;
       }
     }
@@ -132,10 +133,11 @@
 
     private void TestHorizonTextBox_KeyDown(object sender, KeyEventArgs e) {
-      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return)) {
         TestHorizonLabel.Select();  // select label to validate data
-
-      if (e.KeyCode == Keys.Escape) {
+        e.SuppressKeyPress = true;
+      } else if (e.KeyCode == Keys.Escape) {
         TestHorizonTextBox.Text = Content.TestHorizon.ToString();
         TestHorizonLabel.Select();  // select label to validate data
+        e.SuppressKeyPress = true;
       }
     }